#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

// array printing utility
void printarr(int*A,int N){
  for (int iii=0;iii<N;++iii){
    printf("%d ",A[iii]);
    }
    printf("\n");
}


// array shuffling utility
void naiveShuffle(int*A,int N){
  srand(time(NULL));
  for (int iii=0;iii<N;++iii){
    int jjj;
    do{
    jjj=rand()%N;
    } while(iii==jjj);
    int buff = A[iii];
    A[iii]=A[jjj];
    A[jjj]=buff;
  }
}


// arg pack
struct Args{
  int* A;
  int N;
};


void merge(int* A, int N){
  // Copiati A
  int* buffer = (int*)malloc(sizeof(int)*N);
  for(int iii=0; iii<N;++iii){
    buffer[iii]=A[iii];
  }
  
  // Puntatori al primo e ultimo elemento delle due metà di A
  int *l = buffer, *lf = buffer + N/2;
  int *r = lf, *rf = buffer + N;
  while(1){
    if(l<lf){
      if(r<rf && *r<*l){
        *A=*r;
        ++r;
      }
      else{
        *A=*l;
        ++l;
      }
    }
    else if(r<rf){
      *A=*r;
      ++r;
    }
    else{
      break;
    }
    ++A;
  }
  free(buffer);
}


void* mergeSort(void* args){
//unpack args
  int* A = ((struct Args*)args)->A;
  int N = ((struct Args*)args)->N;
  //base case
  if(N<2){
  return NULL;
  }
  //recursive case
  pthread_t tl, tr;
  struct Args argl;
  argl.A = A;
  argl.N = N/2;
  pthread_create(&tl,NULL,mergeSort,&argl);
  struct Args argr;
  argr.A = A+N/2;
  argr.N = N/2+N%2;
  pthread_create(&tr,NULL,mergeSort,&argr);
  //wait before merging
  pthread_join(tl,NULL);
  pthread_join(tr,NULL);
  merge(A,N);
  printarr(A,N);
}


int main(){
  int N=20;
  int* A = (int*)malloc(sizeof(int)*N);;
  for (int iii=0;iii<N;++iii){
    A[iii]=iii+1;
  }
  
  //shuffle array
  naiveShuffle(A,N);
  printarr(A,N);
  
  struct Args args;
  args.A = A;
  args.N = N;
  mergeSort(&args);
  
  free(A);
  return 0;
}
